/*
 *
 *
 *
 */
#ifndef __TDM_DEVICE_H__
#define __TDM_DEVICE_H__

struct tdm_device_ops {
	tdm_status_t (* device_open)(struct tdm_device *dev);
	tdm_status_t (* device_close)(struct tdm_device *dev);

	tdm_status_t (* device_add_port)(struct tdm_device *dev, struct tdm_port *port);
	tdm_status_t (* device_remove_port)(struct tdm_device *dev, struct tdm_port *port);
};

#ifdef LIBTDM_INTERNAL
struct tdm_device {
	struct tdm_object obj;

	struct tdm_device_ops *ops;

	struct dlist_head device_list;

	unsigned int      nr_ports;
	struct dlist_head ports;
};
#endif

struct tdm_device *tdm_object_to_device(struct tdm_object *obj);
struct tdm_module *tdm_device_get_module(struct tdm_device *dev);

struct tdm_device *tdm_device_new(const char *name, const struct tdm_device_ops *ops);
tdm_status_t tdm_device_destroy(struct tdm_device *dev);

tdm_status_t tdm_device_add_port(struct tdm_device *device, struct tdm_port *port);
tdm_status_t tdm_device_remove_port(struct tdm_device *device, struct tdm_port *port);

int tdm_device_has_port(struct tdm_device *dev, struct tdm_port *port);

#ifdef LIBTDM_INTERNAL
tdm_status_t tdm_register_device(struct tdm_device *dev);
tdm_status_t tdm_unregister_device(struct tdm_device *dev);
tdm_status_t tdm_init_devices(void);
#endif

#endif /* __TDM_DEVICE_H__ */
