/*
 *
 *
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdlib.h>

#include "utils/dlist.h"

#include "tdm_common.h"
#include "tdm_object.h"
#include "tdm_log.h"

#include "tdm_policy.h"

static DLIST_HEAD(tdm_policy_list);

tdm_status_t tdm_module_register_policy(struct tdm_module *mod, const struct tdm_policy_def *def)
{
	struct tdm_policy *policy = NULL;

	policy = (struct tdm_policy *)tdm_object_new(def->name, sizeof(*policy));
	if (!policy)
		return TDM_STATUS_GENERR;

	tdm_object_set_type(policy, TDM_OBJECT_POLICY);
	tdm_object_set_owner(policy, mod);


	/* TOOD: locking */

/*
	if (tdm_hash_insert(tdm_object_name(policy), policy) != TDM_STATUS_SUCCESS) {
		tdm_error("%s: failed to register protocol\n", name);
		goto error;
	}
 */

	dlist_insert_tail(&tdm_policy_list, &policy->policy_list);

	/* TOOD: locking */

	return TDM_STATUS_SUCCESS;

error:
	tdm_object_destroy((struct tdm_object *)policy);
	return TDM_STATUS_GENERR;
}
