/*
 * libtdm private header file
 *
 */
#ifndef _TDM_PRIVATE_H_
#define _TDM_PRIVATE_H_

/*
 * internal, tdm_priv.h
 */
#if defined(HAVE_GCC_VISIBILITY) || defined(HAVE_SUNCC_VISIBILITY)
#define TDM_API	__attribute__((visibility("default")))
#else
#define TDM_API
#endif

#ifndef ARRAY_SIZE
#define ARRAY_SIZE(x)	(sizeof(x) / sizeof(x[0]))
#endif

#ifndef ACCESS_ONCE
#define ACCESS_ONCE(x)	(*(volatile typeof(x) *)&(x))
#endif

#ifndef offset_of
#define offset_of(type, member)	\
	(unsigned long)&(((type *)0)->member)
#endif

#ifndef container_of
#define container_of(x, type, member)	\
	((type *)((unsigned long)(x) - offset_of(type, member)))
#endif

#if defined(__GNUC__)
#define likely(x)	__builtin_expect(!!(x), 1)
#define unlikely(x)	__builtin_expect(!!(x), 0)
#else
#define likely(x)	(x)
#define unlikely(x) 	(x)
#endif

#endif /* _TDM_PRIVATE_H_ */
